=encoding utf8

=head1 NAME

Mail::Box::Locker::POSIX - lock a folder using kernel file-locking

=head1 INHERITANCE

 Mail::Box::Locker::POSIX
   is a Mail::Box::Locker
   is a Mail::Reporter

=head1 SYNOPSIS

  See Mail::Box::Locker

=head1 DESCRIPTION

This locker object is created by the folder to get an exclusive lock on
the file which contains the data using the kernel's POSIX facilities.  This
lock is created on a separate file-handle to the folder file, so not the
handle which is reading.

B<WARNING>: Not all platforms support POSIX locking (via fcntl) and not
always in the same way.  This implementation does not use XS to access
the structure of fcntl(): it is better to use the ::FcntlLock which does.
No, this implementation "guesses" the location of the bytes.

Extends L<"DESCRIPTION" in Mail::Box::Locker|Mail::Box::Locker/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Locker|Mail::Box::Locker/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Locker|Mail::Box::Locker/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Box::Locker/"METHODS">

 -Option    --Defined in       --Default
  expires     Mail::Box::Locker  1 hour
  file        Mail::Box::Locker  undef
  folder      Mail::Box::Locker  <C<undef>>
  method      Mail::Box::Locker  POSIX
  posix_file                     <C<undef>>
  timeout     Mail::Box::Locker  10

=over 2

=item expires => $seconds

=item file => $file

=item folder => $folder

=item method => $name|CLASS|\@names

=item posix_file => FILENAME

Alternative name for C<file>, especially useful to avoid confusion
when the multi-locker is used.

=item timeout => $seconds|'NOTIMEOUT'

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Locker|Mail::Box::Locker/"Attributes">.

=over 4

=item $obj-E<gt>B<expires>( [SECONDS] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<filename>( [$filename] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<folder>( [$folder] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<timeout>( [SECONDS] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=back

=head2 Locking

Extends L<"Locking" in Mail::Box::Locker|Mail::Box::Locker/"Locking">.

=over 4

=item $obj-E<gt>B<hasLock>()

Inherited, see L<Mail::Box::Locker/"Locking">

=item $obj-E<gt>B<isLocked>()

Inherited, see L<Mail::Box::Locker/"Locking">

=item $obj-E<gt>B<lock>()

Inherited, see L<Mail::Box::Locker/"Locking">

=item $obj-E<gt>B<unlock>()

Inherited, see L<Mail::Box::Locker/"Locking">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Locker|Mail::Box::Locker/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Locker|Mail::Box::Locker/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box::Locker/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: folder $name already lockf'd.

Cast by C<lock()>

=item Fault: unable to check lock file $file for $folder: $!

To check whether the C<$file> is used to flock a C<$folder>, the file must be
opened.  Apparently this fails, which does not mean that the folder is
locked neither that it is unlocked.
Cast by C<isLocked()>

=item Fault: unable to open POSIX lock file $file for $folder: $!

For POSIX style locking, a C<$folder> it must be opened, which does not
succeed for the specified reason.
Cast by C<lock()>

=item Fault: will never get a POSIX lock at $file for $folder: $!

Tried to lock the C<$folder>, but it did not succeed.  The error code received
from the OS indicates that it will not succeed ever, so we do not need to
try again.
Cast by C<lock()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.02,
built on April 10, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

